<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="sql key" prop="sqlKey">
        <el-input
          v-model="queryParams.sqlKey"
          placeholder="请输入sql key"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['system:sql:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="Edit"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['system:sql:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['system:sql:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          v-hasPermi="['system:sql:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="sqlList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <!-- <el-table-column label="id" align="center" prop="id" /> -->
      <el-table-column label="sql key" align="center" prop="sqlKey" />
      <!-- <el-table-column label="内容" align="center" prop="sqlContent" /> -->
      <el-table-column label="说明" align="center" prop="description" />
      <el-table-column label="备注" align="center" prop="remark" />
      <!-- <el-table-column label="参数配置" align="center" prop="paramsConfig" /> -->
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['system:sql:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['system:sql:remove']">删除</el-button>
          <el-button link type="primary" icon="Search" @click="executeSql(scope.row)" >执行</el-button>

          
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改动态sql执行config对话框 -->
    <el-dialog :title="title" v-model="open" width="60%" append-to-body>
      <el-form ref="sqlRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="sql key" prop="sqlKey">
          <el-input v-model="form.sqlKey" placeholder="请输入sql key" />
        </el-form-item>
        <el-form-item label="内容" prop="sqlContent">
           <SqlEdit ref="sqlEdit" v-model="form.sqlContent" />
        </el-form-item>
        <el-form-item label="说明" prop="description">
          <el-input v-model="form.description" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="参数配置" prop="paramsConfig">
          <el-input v-model="form.paramsConfig" type="textarea" placeholder="请输入内容" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Sql">
import { listSql, getSql, delSql, addSql, updateSql, executeSqlByKeyAndParam } from "@/api/system/sql"

const { proxy } = getCurrentInstance()

const sqlList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref("")

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    sqlKey: null,
    sqlContent: null,
    description: null,
    paramsConfig: null
  },
  rules: {
    sqlKey: [
      { required: true, message: "sql key不能为空", trigger: "blur" }
    ],
    sqlContent: [
      { required: true, message: "内容不能为空", trigger: "blur" }
    ],
    createTime: [
      { required: true, message: "创建时间不能为空", trigger: "blur" }
    ],
    updateTime: [
      { required: true, message: "更新时间不能为空", trigger: "blur" }
    ],
  }
})

const { queryParams, form, rules } = toRefs(data)

/** 查询动态sql执行config列表 */
function getList() {
  loading.value = true
  listSql(queryParams.value).then(response => {
    sqlList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

// 取消按钮
function cancel() {
  open.value = false
  reset()
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    sqlKey: null,
    sqlContent: null,
    description: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    remark: null,
    paramsConfig: null
  }
  proxy.resetForm("sqlRef")
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef")
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset()
  open.value = true
  title.value = "添加动态sql执行config"
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _id = row.id || ids.value
  getSql(_id).then(response => {
    form.value = response.data
    open.value = true
    title.value = "修改动态sql执行config"
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["sqlRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateSql(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功")
          open.value = false
          getList()
        })
      } else {
        addSql(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功")
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value
  proxy.$modal.confirm('是否确认删除动态sql执行config编号为"' + _ids + '"的数据项？').then(function() {
    return delSql(_ids)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess("删除成功")
  }).catch(() => {})
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('system/sql/export', {
    ...queryParams.value
  }, `sql_${new Date().getTime()}.xlsx`)
}

/** 执行 */
function executeSql(row) {
  executeSqlByKeyAndParam(row.sqlKey,row.paramsConfig || {}).then(response => {
    proxy.$modal.msgSuccess("执行成功:"+JSON.stringify(response.data) )
  })
}

getList()
</script>
